//#include <Windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "Param.h"

Param::Param()
{
}

Param::~Param()
{
}

bool  Param::isOption(int argc, char **argv, char *option)
{
  int  i;

  for ( i=0 ; i<argc ; i++ ) {
    if ( argv[i][0]=='-' && strcmp(&(argv[i][1]),option)==0 ) {
      return(true);
    }
  }

  return(false);
}

char  *Param::readOption(int argc, char **argv, char *option)
{
  int  i;

  for ( i=0 ; i<argc ; i++ ) {
    if ( argv[i][0]=='-' && strcmp(&(argv[i][1]),option)==0 ) {
      if ( i<(argc-1) )
        if ( argv[i+1][0]!='-' ) {
          return(argv[i+1]);
        }
    }
  }

  return(NULL);
}

char  *Param::readOption(int argc, char **argv, char *option, char *def)
{
  char  *ret = readOption(argc, argv, option);
  if ( !ret )
    return(def);
  else
    return(ret);
}

int Param::readOptionTab(int argc, char **argv, char *option, int *tab)
{
  int  i, n=0;
  
  for ( i=0 ; i<argc ; i++ ) {
    if ( argv[i][0]=='-' && strcmp(&(argv[i][1]),option)==0 ) {
      while ( i<(argc-1) ) {
        if ( argv[i+1][0]!='-' ) {
          tab[n++] = atoi(argv[i+1]);
        }
        i++;
      }
    }
  }

  return(n);
}

int Param::synopsis()
{

  printf("============================================================\n");
  printf("\tFADING\n");
  printf("------------------------------------------------------------\n");
  printf("\tCOPYRIGHT (c) 2011 Technicolor\n");
  printf("\tAll rights reserved.  \n");
  printf("------------------------------------------------------------\n");
  printf("\tP.Bordes\t(Corporate Research)\n");
  printf("============================================================\n");
  printf("\n");

  printf("Synopsis:\tfading.exe -srcInfo source.yuv -decInfo decoded.yuv -sizeX sx -sizeY sy -nbIma nbima -mode (PSNR,SSIM,DFD) [-reorderPoc]\n\n");

  printf("\t-srcInfo\tReference or Source Info file (FRAMEs or FIELDs).\n");
  printf("\t-srcYuv\tReference or Source yuv file containing FRAMEs.\n");
  printf("\t-decInfo\tDecoded Info file (FRAMEs or FIELDs).\n");
  printf("\t-sizeX -sizeY\tsrcYuv: YUV Frames size (4:2:0), srcInfo: Frames or fields size (4:2:0).\n");
  printf("\t-field\tInfo files are 'fields' (default is 'frames').\n");
  printf("\t-srcSkip\tFields numbers to skip in 'srcYuv'.\n");
  printf("\t-nbIma\tnumber of images to process.\n");
  printf("\t-bw\texclude borders of width='bw'.\n");
  printf("\t-mode\tPSNR or SSIM.\n");

  printf("\n");

  return(1);
}


