#ifndef __TCOMLUT3DDOUBLE__
#define __TCOMLUT3DDOUBLE__

#include "TypeDef.h"
#include "TComLut3D.h"

typedef struct {
  Double  dY, dU, dV;
  Double  dY0, dU0, dV0;
  Int     dist;
  Int     iNbSample;
} nodeD; // node

class  TComLut3DDouble
{
  Int     m_nbp;
  nodeD   *m_yuvLut;
  Int     m_dr;
  Int     m_dg;
  Int     m_db;

  Void  append( Short sY0, Short sU0, Short sV0, Short sY1, Short sU1, Short sV1 );
  inline  nodeD*  getNode( int r, int g, int b );

  Void  eliminationGaussJordan( TComLut3D* outLut3D );

public:
  TComLut3DDouble(int nbp);
  ~TComLut3DDouble();

  Void  append( TComPicYuv* pPicYuv0, TComPicYuv* pPicYuv1 );
  Void  compute( TComLut3D* outLut3D );

};

inline  nodeD *TComLut3DDouble::getNode( int r, int g, int b )
{
  return( m_yuvLut + r*m_nbp*m_nbp + g*m_nbp + b );
}

#endif

