#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "TComPicYuv.h"

/*
static Pel  xClip( Pel x )
{ 
  //g_uiIBDI_MAX     = ((1<<(g_uiBitDepth+g_uiBitIncrement))-1);
  //Int max = (Int)g_uiIBDI_MAX;
#define Max 255
  Pel pel = (Pel)( (x < 0) ? 0 : ((x > Max) ? Max : x) );
  return( pel );
}
*/

TComPicYuv::TComPicYuv()
{
  m_piPicOrgY = NULL;
  m_piPicOrgU = NULL;
  m_piPicOrgV = NULL;
}

TComPicYuv::~TComPicYuv()
{
  if ( m_piPicOrgY ) free( m_piPicOrgY );
  if ( m_piPicOrgU ) free( m_piPicOrgU );
  if ( m_piPicOrgV ) free( m_piPicOrgV );
}

Void	TComPicYuv::create( Int iPicWidth, Int iPicHeight, Int iMarginX, Int iMarginY )
{
  m_iPicWidth   = iPicWidth;
  m_iPicHeight  = iPicHeight;
  m_iMarginX    = iMarginX;
  m_iMarginY    = iMarginY;

  Int sX  = m_iPicWidth       + (iMarginX<<1);
  Int sY  = m_iPicHeight      + (iMarginY<<1);
  Int sCX = (m_iPicWidth>>1)  + (iMarginX<<1);
  Int sCY = (m_iPicHeight>>1) + (iMarginY<<1);

  m_piPicOrgY = (Pel *)malloc( sizeof(Pel) * (sX)  * (sY) );
  m_piPicOrgU = (Pel *)malloc( sizeof(Pel) * (sCX) * (sCY) );
  m_piPicOrgV = (Pel *)malloc( sizeof(Pel) * (sCX) * (sCY) );

  m_piPicOrgY += iMarginY * getStride()  + iMarginX;
  m_piPicOrgU += iMarginY * getCStride() + iMarginX;
  m_piPicOrgV += iMarginY * getCStride() + iMarginX;
}

static  unsigned char *puRead=NULL;

Void	TComPicYuv::read( FILE *fic, int poc, int inputBitDepth )
{
  int sizeImage = m_iPicWidth*m_iPicHeight + 2*((m_iPicWidth>>1)*(m_iPicHeight>>1));

  if ( inputBitDepth <= 8 ) {

    //fseek(fic,poc*sizeImage, SEEK_SET);
    __int64 offset  = (__int64)poc*(__int64)sizeImage;
    if ( _fseeki64(fic,offset, SEEK_SET) ) {
      printf("TComPicYuv::read():\t_fseeki64() failed.\n");
      exit(0);
    }

    if ( !puRead )    puRead = (unsigned char *)malloc(sizeof(unsigned char)*sizeImage);

    fread(puRead, 1, sizeImage, fic);
    int pos=0;
/*
    sizeImage = m_iPicWidth*m_iPicHeight ;
    for ( int i=0 ; i<sizeImage ; i++ , pos++ )
      m_piPicOrgY[i] = (short)pu[pos];

    sizeImage = (m_iPicWidth>>1)*(m_iPicHeight>>1) ;
    for ( int i=0 ; i<sizeImage ; i++ , pos++ )
      m_piPicOrgU[i] = (short)pu[pos];
    for ( int i=0 ; i<sizeImage ; i++ , pos++ )
      m_piPicOrgV[i] = (short)pu[pos];
*/

    Pel *pic  = m_piPicOrgY;
    for ( int i=0 ; i<m_iPicHeight ; i++ ) {
      for ( int j=0 ; j<m_iPicWidth ; j++ , pos++ )
        pic[j] = (short)puRead[pos];

      pic += getStride();
    }

    pic  = m_piPicOrgU;
    for ( int i=0 ; i<(m_iPicHeight>>1) ; i++ ) {
      for ( int j=0 ; j<(m_iPicWidth>>1) ; j++ , pos++ )
        pic[j] = (short)puRead[pos];

      pic += getCStride();
    }

    pic  = m_piPicOrgV;
    for ( int i=0 ; i<(m_iPicHeight>>1) ; i++ ) {
      for ( int j=0 ; j<(m_iPicWidth>>1) ; j++ , pos++ )
        pic[j] = (short)puRead[pos];

      pic += getCStride();
    }

    free(puRead);
    puRead = NULL;
  }
  else if ( inputBitDepth > 8 ) {

    //fseek(fic,poc*sizeImage*2, SEEK_SET);
    __int64 offset  = 2*(__int64)poc*(__int64)sizeImage;
    if ( _fseeki64(fic,offset, SEEK_SET) ) {
      printf("TComPicYuv::read():\t_fseeki64() failed.\n");
      exit(0);
    }
/*
    fread( m_piPicOrgY, 1, m_iPicWidth*m_iPicHeight*2, fic );
    fread( m_piPicOrgU, 1, (m_iPicWidth>>1)*(m_iPicHeight>>1)*2, fic );
    fread( m_piPicOrgV, 1, (m_iPicWidth>>1)*(m_iPicHeight>>1)*2, fic );
*/
    Pel *pic  = m_piPicOrgY;
    for ( int i=0 ; i<m_iPicHeight ; i++ ) {
      fread( pic, 1, m_iPicWidth*2, fic );

      pic += getStride();
    }

    pic  = m_piPicOrgU;
    for ( int i=0 ; i<(m_iPicHeight>>1) ; i++ ) {
      fread( pic, 1, m_iPicWidth, fic );

      pic += getCStride();
    }

    pic  = m_piPicOrgV;
    for ( int i=0 ; i<(m_iPicHeight>>1) ; i++ ) {
      fread( pic, 1, m_iPicWidth, fic );

      pic += getCStride();
    }

  }
  else {
    printf("TComPicYuv::read():\tinputBitDepth=%d not supported.\n", inputBitDepth);
    exit(0);
  }

}

Void	TComPicYuv::write( FILE *fic, int poc, int inputBitDepth, int outputBitDepth )
{
/*
  if ( m_iMarginX!=0 || m_iMarginY!=0 ) {
    printf("TComPicYuv::write() with marge not supported.\n");
    exit(0);
  }
*/
  int sizeImage = m_iPicWidth*m_iPicHeight + 2*((m_iPicWidth>>1)*(m_iPicHeight>>1));
  
  if ( outputBitDepth <= 8 ) {
    //fseek(fic,poc*sizeImage, SEEK_SET);
    __int64 offset  = (__int64)poc*(__int64)sizeImage;
    _fseeki64(fic,offset, SEEK_SET);
  }
  else if ( outputBitDepth > 8 ) {
    //fseek(fic,2*poc*sizeImage, SEEK_SET);
    __int64 offset  = 2*(__int64)poc*(__int64)sizeImage;
    _fseeki64(fic,offset, SEEK_SET);
  }

  sizeImage = m_iPicWidth*m_iPicHeight;
  unsigned char *puc = (unsigned char *)malloc(sizeof(unsigned char)*sizeImage*4);

  for ( Int comp=0 ; comp<3 ; comp++ ) {

    short *pu;
    if ( comp == 0 )  pu  = m_piPicOrgY;
    if ( comp == 1 )  pu  = m_piPicOrgU;
    if ( comp == 2 )  pu  = m_piPicOrgV;

    Int sX = ( comp == 0 ) ? m_iPicWidth  : (m_iPicWidth>>1);
    Int sY = ( comp == 0 ) ? m_iPicHeight : (m_iPicHeight>>1);

    if ( inputBitDepth <= 8 && outputBitDepth <= 8 ) {
      //for ( int i=0 ; i<sizeImage ; i++ ) puc[i] = (unsigned char)pu[i];

      Int pos=0;
      Pel *pic  = pu;
      for ( int i=0 ; i<sY ; i++ ) {
        for ( int j=0 ; j<sX ; j++ , pos++ )
          puc[pos] = (unsigned char)pic[j];

        pic += ( comp == 0 ) ? getStride() : getCStride();
      }

    }
    else if ( inputBitDepth > 8 && outputBitDepth <= 8 ) {
      //for ( int i=0 ; i<sizeImage ; i++ ) puc[i] = (unsigned char)(pu[i] >> (inputBitDepth-outputBitDepth));

      Int pos=0;
      Pel *pic  = pu;
      for ( int i=0 ; i<sY ; i++ ) {
        for ( int j=0 ; j<sX ; j++ , pos++ )
          puc[pos] = (unsigned char)(pic[j] >> (inputBitDepth-outputBitDepth));

        pic += ( comp == 0 ) ? getStride() : getCStride();
      }

    }
    else {
      Int pos=0;
      Pel *pic  = pu;
      for ( int i=0 ; i<sY ; i++ ) {
        for ( int j=0 ; j<sX ; j++ , pos++ ) {
          puc[2*pos]    = (unsigned char)( pic[j] & 0xFF );
          puc[2*pos+1]  = (unsigned char)( pic[j] >> 8 );
        }
        pic += ( comp == 0 ) ? getStride() : getCStride();
      }

    }

    if ( outputBitDepth <= 8 )
      fwrite(puc, 1, sizeImage, fic);
    else
      fwrite(puc, 1, sizeImage*2, fic);

    sizeImage = (m_iPicWidth>>1)*(m_iPicHeight>>1);
  }

  fflush(fic);
  free(puc);
}

Void	TComPicYuv::diff( TComPicYuv *pYuv, TComPicYuv *pYuvDiff )
{
  Int iHeight   = getHeight();
  Int iWidth    = getWidth();
  Int iStride   = getStride();
  Int iCStride  = getCStride();

  Pel*	Lum0    = getLumaAddr();
  Pel*	Cb0	    = getCbAddr();
  Pel*	Cr0	    = getCrAddr();
  Pel*	Lum1    = pYuv->getLumaAddr();
  Pel*	Cb1	    = pYuv->getCbAddr();
  Pel*	Cr1	    = pYuv->getCrAddr();
  Pel*	Lum2    = pYuvDiff->getLumaAddr();
  Pel*	Cb2	    = pYuvDiff->getCbAddr();
  Pel*	Cr2	    = pYuvDiff->getCrAddr();

  for( Int y = 0; y < iHeight ; y++ ) {
    for( Int x = 0; x < iWidth ; x++ ) {
    
      Lum2[x]   = ABS( Lum1[x]   - Lum0[x]   );
      Cb2[x>>1] = ABS( Cb1[x>>1] - Cb0[x>>1] );
      Cr2[x>>1] = ABS( Cr1[x>>1] - Cr0[x>>1] );

    }
    Lum0  += iStride;
    Lum1  += iStride;
    Lum2  += iStride;
    if ( (y % 2) ) {
      Cb0 += iCStride;
      Cr0 += iCStride;
      Cb1 += iCStride;
      Cr1 += iCStride;
      Cb2 += iCStride;
      Cr2 += iCStride;
    }
  }

}

Void TComPicYuv::extendPicBorder()
{
  xExtendPicCompBorder( getLumaAddr(), getStride(),  getWidth(),      getHeight(),      m_iMarginX, m_iMarginY   );
  xExtendPicCompBorder( getCbAddr()  , getCStride(), getWidth() >> 1, getHeight() >> 1, m_iMarginX, m_iMarginY );
  xExtendPicCompBorder( getCrAddr()  , getCStride(), getWidth() >> 1, getHeight() >> 1, m_iMarginX, m_iMarginY );
}

Void TComPicYuv::xExtendPicCompBorder(Pel* piTxt, Int iStride, Int iWidth, Int iHeight, Int iMarginX, Int iMarginY  )
{
  Int   x, y;
  Pel*  pi;
  
  pi = piTxt;
  for ( y = 0; y < iHeight; y++)
  {
    for ( x = 0; x < iMarginX; x++ )
    {
      pi[ -iMarginX + x ] = pi[0];
      pi[    iWidth + x ] = pi[iWidth-1];
    }
    pi += iStride;
  }
  
  pi -= (iStride + iMarginX);
  for ( y = 0; y < iMarginY; y++ )
  {
    memcpy( pi + (y+1)*iStride, pi, sizeof(Pel)*(iWidth + (iMarginX<<1)) );
  }
  
  pi -= ((iHeight-1) * iStride);
  for ( y = 0; y < iMarginY; y++ )
  {
    memcpy( pi - (y+1)*iStride, pi, sizeof(Pel)*(iWidth + (iMarginX<<1)) );
  }
}

