#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "TypeDef.h"
#include "misc.h"


Void  assert(char *comment, Bool bTest)
{
  if ( !bTest ) {
    printf("assertion failed:\t%s\n", comment);
    exit(0);
  }
}

static  unsigned char *pu=NULL;
short *readImage(FILE *fic, int poc, int sizeX, int sizeY, int inputBitDepth, short *pima)
{
  int sizeImage = sizeX*sizeY + 2*((sizeX>>1)*(sizeY>>1));

  if ( !pima )  pima = (short *)malloc(sizeof(short)*sizeImage);

  if ( inputBitDepth <= 8 ) {

    fseek(fic,poc*sizeImage, SEEK_SET);

    if ( !pu )    pu = (unsigned char *)malloc(sizeof(unsigned char)*sizeImage);

    fread(pu, 1, sizeImage, fic);

    for ( int i=0 ; i<sizeImage ; i++ )
      pima[i] = (short)pu[i];
  }
  else if ( inputBitDepth > 8 ) {

    fseek(fic,poc*sizeImage*2, SEEK_SET);

    fread(pima, 1, sizeImage*2, fic);
  }
  else {
    printf("readImage():\tinputBitDepth=%d not supported.\n", inputBitDepth);
    exit(0);
  }

  return(pima);
}

void  *allocImage(int sizeX, int sizeY, int inputBitDepth)
{
  int sizeImage = sizeX*sizeY + 2*((sizeX>>1)*(sizeY>>1));

  unsigned char *puc=NULL;
  short         *psh=NULL;

  if ( inputBitDepth <= 8 ) {
    puc = (unsigned char *)malloc(sizeof(unsigned char)*sizeImage);
    return(puc);
  }
  else {
    psh = (short *)malloc(sizeof(short)*sizeImage);
    return(psh);
  }
}

void  writeImage(FILE *fic, int poc, int sizeX, int sizeY, int inputBitDepth, short *pu)
{
  int sizeImage = sizeX*sizeY + 2*((sizeX>>1)*(sizeY>>1));
  fseek(fic,poc*sizeImage, SEEK_SET);

  unsigned char *puc = (unsigned char *)malloc(sizeof(unsigned char)*sizeImage);

  if ( inputBitDepth <= 8 )
    for ( int i=0 ; i<sizeImage ; i++ ) puc[i] = (unsigned char)pu[i];
  else {
    int shift = inputBitDepth - 8;
    int add   = 1 << (shift-1);
    for ( int i=0 ; i<sizeImage ; i++ ) puc[i] = (unsigned char)((pu[i]+add) >> shift);
  }

  fwrite(puc, 1, sizeImage, fic);

  free(puc);
}

